## rgbds 0.9.3

=== Makefile ===
# SPDX-License-Identifier: MIT

.SUFFIXES:
.SUFFIXES: .cpp .y .o

.PHONY: all clean install checkdiff develop debug profile coverage iwyu mingw32 mingw64 wine-shim dist

# User-defined variables

Q       := @
PREFIX  := /usr/local
bindir  := ${PREFIX}/bin
mandir  := ${PREFIX}/share/man
SUFFIX  :=
STRIP   := -s
BINMODE := 755
MANMODE := 644

# Other variables

PKG_CONFIG := pkg-config
PNGCFLAGS  := `${PKG_CONFIG} --cflags libpng`
PNGLDFLAGS := `${PKG_CONFIG} --libs-only-L libpng`
PNGLDLIBS  := `${PKG_CONFIG} --libs-only-l libpng`

# Note: if this comes up empty, `version.cpp` will automatically fall back to last release number
VERSION_STRING := `git --git-dir=.git -c safe.directory='*' describe --tags --dirty --always 2>/dev/null`

WARNFLAGS := -Wall -pedantic -Wno-unknown-warning-option -Wno-gnu-zero-variadic-macro-arguments

# Overridable CXXFLAGS
CXXFLAGS     ?= -O3 -flto -DNDEBUG
# Non-overridable CXXFLAGS
REALCXXFLAGS := ${CXXFLAGS} ${WARNFLAGS} -std=c++2a -I include -fno-exceptions -fno-rtti
# Overridable LDFLAGS
LDFLAGS      ?=
# Non-overridable LDFLAGS
REALLDFLAGS  := ${LDFLAGS} ${WARNFLAGS} -DBUILD_VERSION_STRING=\"${VERSION_STRING}\"

# Wrapper around bison that passes flags depending on what the version supports
BISON := src/bison.sh

RM := rm -rf

# Used for checking pull requests
BASE_REF := origin/master

# Rules to build the RGBDS binaries

all: rgbasm rgblink rgbfix rgbgfx

rgbasm_obj := \
	src/asm/charmap.o \
	src/asm/fixpoint.o \
	src/asm/format.o \
	src/asm/fstack.o \
	src/asm/lexer.o \
	src/asm/macro.o \
	src/asm/main.o \
	src/asm/opt.o \
	src/asm/output.o \
	src/asm/parser.o \
	src/asm/rpn.o \
	src/asm/section.o \
	src/asm/symbol.o \
	src/asm/warning.o \
	src/extern/getopt.o \
	src/extern/utf8decoder.o \
	src/error.o \
	src/linkdefs.o \
	src/opmath.o \
	src/util.o

src/asm/lexer.o src/asm/main.o: src/asm/parser.hpp

rgblink_obj := \
	src/link/assign.o \
	src/link/main.o \
	src/link/object.o \
	src/link/output.o \
	src/link/patch.o \
	src/link/script.o \
	src/link/sdas_obj.o \
	src/link/section.o \
	src/link/symbol.o \
	src/extern/getopt.o \
	src/extern/utf8decoder.o \
	src/error.o \
	src/linkdefs.o \
	src/opmath.o \
	src/util.o

src/link/main.o: src/link/script.hpp

rgbfix_obj := \
	src/fix/main.o \
	src/extern/getopt.o \
	src/error.o

rgbgfx_obj := \
	src/gfx/main.o \
	src/gfx/pal_packing.o \
	src/gfx/pal_sorting.o \
	src/gfx/pal_spec.o \
	src/gfx/process.o \
	src/gfx/proto_palette.o \
	src/gfx/reverse.o \
	src/gfx/rgba.o \
	src/extern/getopt.o \
	src/error.o

rgbasm: ${rgbasm_obj}
	$Q${CXX} ${REALLDFLAGS} -o $@ ${rgbasm_obj} ${REALCXXFLAGS} src/version.cpp -lm

rgblink: ${rgblink_obj}
	$Q${CXX} ${REALLDFLAGS} -o $@ ${rgblink_obj} ${REALCXXFLAGS} src/version.cpp

rgbfix: ${rgbfix_obj}
	$Q${CXX} ${REALLDFLAGS} -o $@ ${rgbfix_obj} ${REALCXXFLAGS} src/version.cpp

rgbgfx: ${rgbgfx_obj}
	$Q${CXX} ${REALLDFLAGS} ${PNGLDFLAGS} -o $@ ${rgbgfx_obj} ${REALCXXFLAGS} ${PNGLDLIBS} src/version.cpp

test/gfx/randtilegen: test/gfx/randtilegen.cpp
	$Q${CXX} ${REALLDFLAGS} ${PNGLDFLAGS} -o $@ $^ ${REALCXXFLAGS} ${PNGCFLAGS} ${PNGLDLIBS}

test/gfx/rgbgfx_test: test/gfx/rgbgfx_test.cpp
	$Q${CXX} ${REALLDFLAGS} ${PNGLDFLAGS} -o $@ $^ ${REALCXXFLAGS} ${PNGCFLAGS} ${PNGLDLIBS}

# Rules to process files

# We want the Bison invocation to pass through our rules, not default ones
.y.o:

.y.cpp:
	$Q${BISON} $@ $<

# Bison-generated C++ files have an accompanying header
src/asm/parser.hpp: src/asm/parser.cpp
	$Qtouch $@
src/link/script.hpp: src/link/script.cpp
	$Qtouch $@

# Only RGBGFX uses libpng (POSIX make doesn't support pattern rules to cover all these)
src/gfx/main.o: src/gfx/main.cpp
	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
src/gfx/pal_packing.o: src/gfx/pal_packing.cpp
	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
src/gfx/pal_sorting.o: src/gfx/pal_sorting.cpp
	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
src/gfx/pal_spec.o: src/gfx/pal_spec.cpp
	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
src/gfx/process.o: src/gfx/process.cpp
	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
src/gfx/proto_palette.o: src/gfx/proto_palette.cpp
	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
src/gfx/reverse.o: src/gfx/reverse.cpp
	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
src/gfx/rgba.o: src/gfx/rgba.cpp
	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<

.cpp.o:
	$Q${CXX} ${REALCXXFLAGS} -c -o $@ $<

# Target used to remove all files generated by other Makefile targets

clean:
	$Q${RM} rgbasm rgbasm.exe
	$Q${RM} rgblink rgblink.exe
	$Q${RM} rgbfix rgbfix.exe
	$Q${RM} rgbgfx rgbgfx.exe
	$Qfind src/ -name "*.o" -exec rm {} \;
	$Qfind . -type f \( -name "*.gcno" -o -name "*.gcda" -o -name "*.gcov" \) -exec rm {} \;
	$Q${RM} rgbshim.sh
	$Q${RM} src/asm/parser.cpp src/asm/parser.hpp src/asm/stack.hh
	$Q${RM} src/link/script.cpp src/link/script.hpp src/link/stack.hh
	$Q${RM} test/gfx/randtilegen test/gfx/rgbgfx_test

# Target used to install the binaries and man pages.

install: all
	$Qinstall -d ${DESTDIR}${bindir}/ ${DESTDIR}${mandir}/man1/ ${DESTDIR}${mandir}/man5/ ${DESTDIR}${mandir}/man7/
	$Qinstall ${STRIP} -m ${BINMODE} rgbasm ${DESTDIR}${bindir}/rgbasm${SUFFIX}
	$Qinstall ${STRIP} -m ${BINMODE} rgblink ${DESTDIR}${bindir}/rgblink${SUFFIX}
	$Qinstall ${STRIP} -m ${BINMODE} rgbfix ${DESTDIR}${bindir}/rgbfix${SUFFIX}
	$Qinstall ${STRIP} -m ${BINMODE} rgbgfx ${DESTDIR}${bindir}/rgbgfx${SUFFIX}
	$Qinstall -m ${MANMODE} man/rgbasm.1 man/rgblink.1 man/rgbfix.1 man/rgbgfx.1 ${DESTDIR}${mandir}/man1/
	$Qinstall -m ${MANMODE} man/rgbds.5 man/rgbasm.5 man/rgbasm-old.5 man/rgblink.5 ${DESTDIR}${mandir}/man5/
	$Qinstall -m ${MANMODE} man/rgbds.7 man/gbz80.7 ${DESTDIR}${mandir}/man7/

# Target used to check for suspiciously missing changed files.

checkdiff:
	$Qcontrib/checkdiff.bash `git merge-base HEAD ${BASE_REF}`

# This target is used during development in order to prevent adding new issues
# to the source code. All warnings are treated as errors in order to block the
# compilation and make the continous integration infrastructure return failure.
# The rationale for some of the flags is documented in the CMakeLists.

develop:
	$Q${MAKE} WARNFLAGS="${WARNFLAGS} -Werror -Wextra \
		-Walloc-zero -Wcast-align -Wcast-qual -Wduplicated-branches -Wduplicated-cond \
		-Wfloat-equal -Wlogical-op -Wnull-dereference -Wold-style-cast -Wshift-overflow=2 \
		-Wstringop-overflow=4 -Wtrampolines -Wundef -Wuninitialized -Wunused -Wshadow \
		-Wformat=2 -Wformat-overflow=2 -Wformat-truncation=1 \
		-Wno-format-nonliteral -Wno-strict-overflow -Wno-unused-but-set-variable \
		-Wno-type-limits -Wno-tautological-constant-out-of-range-compare -Wvla \
		-D_GLIBCXX_ASSERTIONS -fsanitize=address -fsanitize=undefined \
		-fsanitize=float-divide-by-zero" \
		CXXFLAGS="-ggdb3 -Og -fno-omit-frame-pointer -fno-optimize-sibling-calls"

# This target is used during development in order to more easily debug with gdb.

debug:
	$Qenv ${MAKE} \
		CXXFLAGS="-ggdb3 -O0 -fno-omit-frame-pointer -fno-optimize-sibling-calls"

# This target is used during development in order to more easily profile with callgrind.

profile:
	$Qenv ${MAKE} \
		CXXFLAGS="-ggdb3 -O3 -fno-omit-frame-pointer -fno-optimize-sibling-calls"

# This target is used during development in order to inspect code coverage with gcov.

coverage:
	$Qenv ${MAKE} \
		CXXFLAGS="-ggdb3 -Og --coverage -fno-omit-frame-pointer -fno-optimize-sibling-calls"

# This target is used during development in order to remove unused `#include` headers.

iwyu:
	$Qenv ${MAKE} \
		CXX="include-what-you-use" \
		REALCXXFLAGS="-std=c++2a -I include"

# Targets for the project maintainer to easily create Windows exes.
# This is not for Windows users!
# If you're building on Windows with Cygwin or MinGW, just follow the Unix
# install instructions instead.

mingw32:
	$Q${MAKE} all test/gfx/randtilegen test/gfx/rgbgfx_test \
		CXX=i686-w64-mingw32-g++ \
		CXXFLAGS="-O3 -flto -DNDEBUG -static-libgcc -static-libstdc++" \
		PKG_CONFIG="PKG_CONFIG_SYSROOT_DIR=/usr/i686-w64-mingw32 pkg-config"

mingw64:
	$Q${MAKE} all test/gfx/randtilegen test/gfx/rgbgfx_test \
		CXX=x86_64-w64-mingw32-g++ \
		PKG_CONFIG="PKG_CONFIG_SYSROOT_DIR=/usr/x86_64-w64-mingw32 pkg-config"

wine-shim:
	$Qecho '#!/usr/bin/env bash' > rgbshim.sh
	$Qecho 'WINEDEBUG=-all wine $$0.exe "$${@:1}"' >> rgbshim.sh
	$Qchmod +x rgbshim.sh
	$Qln -s rgbshim.sh rgbasm
	$Qln -s rgbshim.sh rgblink
	$Qln -s rgbshim.sh rgbfix
	$Qln -s rgbshim.sh rgbgfx

# Target for the project maintainer to produce distributable release tarballs
# of the source code.

dist:
	$Qgit ls-files | sed s~^~$${PWD##*/}/~ \
	  | tar -czf rgbds-source.tar.gz -C .. -T -

=== src/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

configure_file(version.cpp _version.cpp ESCAPE_QUOTES)

set(common_src
    "error.cpp"
    "extern/getopt.cpp"
    "_version.cpp"
    )

find_package(BISON 3.0.0 REQUIRED)
set(BISON_FLAGS "-Wall -Dlr.type=ielr")
# Set some optimization flags on versions that support them
if(BISON_VERSION VERSION_GREATER_EQUAL "3.5")
  set(BISON_FLAGS "${BISON_FLAGS} -Dparse.lac=full -Dapi.token.raw=true")
endif()
if(BISON_VERSION VERSION_GREATER_EQUAL "3.6")
  set(BISON_FLAGS "${BISON_FLAGS} -Dparse.error=detailed")
else()
  set(BISON_FLAGS "${BISON_FLAGS} -Dparse.error=verbose")
endif()

BISON_TARGET(ASM_PARSER "asm/parser.y"
             "${PROJECT_SOURCE_DIR}/src/asm/parser.cpp"
             COMPILE_FLAGS "${BISON_FLAGS}"
             DEFINES_FILE "${PROJECT_SOURCE_DIR}/src/asm/parser.hpp"
             )

BISON_TARGET(LINKER_SCRIPT_PARSER "link/script.y"
             "${PROJECT_SOURCE_DIR}/src/link/script.cpp"
             COMPILE_FLAGS "${BISON_FLAGS}"
             DEFINES_FILE "${PROJECT_SOURCE_DIR}/src/link/script.hpp"
             )

set(rgbasm_src
    "${BISON_ASM_PARSER_OUTPUT_SOURCE}"
    "asm/charmap.cpp"
    "asm/fixpoint.cpp"
    "asm/format.cpp"
    "asm/fstack.cpp"
    "asm/lexer.cpp"
    "asm/macro.cpp"
    "asm/main.cpp"
    "asm/opt.cpp"
    "asm/output.cpp"
    "asm/rpn.cpp"
    "asm/section.cpp"
    "asm/symbol.cpp"
    "asm/warning.cpp"
    "extern/utf8decoder.cpp"
    "linkdefs.cpp"
    "opmath.cpp"
    "util.cpp"
    )

set(rgbfix_src
    "fix/main.cpp"
    )

set(rgbgfx_src
    "gfx/main.cpp"
    "gfx/pal_packing.cpp"
    "gfx/pal_sorting.cpp"
    "gfx/pal_spec.cpp"
    "gfx/process.cpp"
    "gfx/proto_palette.cpp"
    "gfx/reverse.cpp"
    "gfx/rgba.cpp"
    "extern/getopt.cpp"
    "error.cpp"
    )

set(rgblink_src
    "${BISON_LINKER_SCRIPT_PARSER_OUTPUT_SOURCE}"
    "link/assign.cpp"
    "link/main.cpp"
    "link/object.cpp"
    "link/output.cpp"
    "link/patch.cpp"
    "link/sdas_obj.cpp"
    "link/section.cpp"
    "link/symbol.cpp"
    "extern/utf8decoder.cpp"
    "linkdefs.cpp"
    "opmath.cpp"
    "util.cpp"
    )

foreach(PROG "asm" "fix" "gfx" "link")
  add_executable(rgb${PROG}
                 ${rgb${PROG}_src}
                 ${common_src}
                 )
  install(TARGETS rgb${PROG} RUNTIME DESTINATION bin)
  # Required to run tests
  set_target_properties(rgb${PROG} PROPERTIES
  # hack for MSVC: no-op generator expression to stop generation of "per-configuration subdirectory"
                        RUNTIME_OUTPUT_DIRECTORY $<1:${CMAKE_SOURCE_DIR}>)
endforeach()

if(LIBPNG_FOUND) # pkg-config
  target_include_directories(rgbgfx PRIVATE ${LIBPNG_INCLUDE_DIRS})
  target_link_directories(rgbgfx PRIVATE ${LIBPNG_LIBRARY_DIRS})
  target_link_libraries(rgbgfx PRIVATE ${LIBPNG_LIBRARIES})
else()
  target_compile_definitions(rgbgfx PRIVATE ${PNG_DEFINITIONS})
  target_include_directories(rgbgfx PRIVATE ${PNG_INCLUDE_DIRS})
  target_link_libraries(rgbgfx PRIVATE ${PNG_LIBRARIES})
endif()

include(CheckLibraryExists)
check_library_exists("m" "sin" "" HAS_LIBM)
if(HAS_LIBM)
  target_link_libraries(rgbasm PRIVATE "m")
endif()

=== test/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

option(USE_NONFREE_TESTS "run tests that build nonfree codebases" ON)
option(USE_EXTERNAL_TESTS "run tests that build external codebases" ON)

if(NOT USE_NONFREE_TESTS)
  set(ONLY_FREE "--only-free")
endif()
if(NOT USE_EXTERNAL_TESTS)
  set(ONLY_INTERNAL "--only-internal")
endif()

add_executable(randtilegen gfx/randtilegen.cpp)
add_executable(rgbgfx_test gfx/rgbgfx_test.cpp)
set_target_properties(randtilegen rgbgfx_test PROPERTIES
# hack for MSVC: no-op generator expression to stop generation of "per-configuration subdirectory"
                      RUNTIME_OUTPUT_DIRECTORY $<1:${CMAKE_CURRENT_SOURCE_DIR}/gfx>)

configure_file(CTestCustom.cmake.in ${CMAKE_BINARY_DIR}/CTestCustom.cmake)

foreach(TARGET randtilegen rgbgfx_test)
  if(LIBPNG_FOUND) # pkg-config
    target_include_directories(${TARGET} PRIVATE ${LIBPNG_INCLUDE_DIRS})
    target_link_directories(${TARGET} PRIVATE ${LIBPNG_LIBRARY_DIRS})
    target_link_libraries(${TARGET} PRIVATE ${LIBPNG_LIBRARIES})
  else()
    target_compile_definitions(${TARGET} PRIVATE ${PNG_DEFINITIONS})
    target_include_directories(${TARGET} PRIVATE ${PNG_INCLUDE_DIRS})
    target_link_libraries(${TARGET} PRIVATE ${PNG_LIBRARIES})
  endif()
endforeach()

add_test(NAME all
         COMMAND ./run-tests.sh ${ONLY_FREE} ${ONLY_INTERNAL}
         WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

=== debian/changelog ===
rgbds (0.9.3-1) unstable; urgency=medium

  * Initial release (Closes: #984927)

 -- Sébastien Noel <sebastien@twolife.be>  Tue, 08 Jul 2025 09:06:16 +0200

=== debian/control ===
Source: rgbds
Section: devel
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Sébastien Noel <sebastien@twolife.be>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13), cmake, bison, pkgconf, libpng-dev
Standards-Version: 4.7.2
Homepage: https://rgbds.gbdev.io
Vcs-Browser: https://salsa.debian.org/twolife/rgbds
Vcs-Git: https://salsa.debian.org/twolife/rgbds.git

Package: rgbds
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Game Boy assembly toolchain
 The Rednex Game Boy Development System provides tools to compile homebrew
 Game Boy ROMs. It consists of:
  - rgbasm (assembler)
  - rgblink (linker)
  - rgbfix (checksum/header fixer)
  - rgbgfx (PNG‐to‐Game Boy graphics converter)

=== debian/watch ===
version=4

opts="pgpmode=none"
https://github.com/gbdev/rgbds/tags .*/[vV]?(\d[^\s+]+)\.tar\.gz

## rgbds 0.9.4

=== CMakeLists.txt ===
# SPDX-License-Identifier: MIT

# 3.9 required for LTO checks
# 3.17 optional for CMAKE_CTEST_ARGUMENTS
cmake_minimum_required(VERSION 3.9..3.17 FATAL_ERROR)

project(rgbds
        LANGUAGES CXX)

include(CTest)

# get real path of source and binary directories
get_filename_component(srcdir "${CMAKE_SOURCE_DIR}" REALPATH)
get_filename_component(bindir "${CMAKE_BINARY_DIR}" REALPATH)

# reject in-source builds, may conflict with Makefile
if(srcdir STREQUAL bindir)
  message("RGBDS should not be built in the source directory.")
  message("Instead, create a separate build directory and specify to CMake the path to the source directory.")
  message(FATAL_ERROR "Terminating configuration")
endif()

option(SANITIZERS "Build with sanitizers enabled" OFF) # Ignored on MSVC
option(MORE_WARNINGS "Turn on more warnings" OFF) # Ignored on MSVC

if(MSVC)
  # MSVC's own standard library triggers warning C5105,
  # "macro expansion producing 'defined' has undefined behavior".
  # Warning C5030 is about unknown attributes (`[[gnu::ATTR]]`), none of ours being load-bearing.
  # Warning C4996 is about using POSIX names, which we want to do for portability.
  # We also opt into the C++20-conformant preprocessor.
  add_compile_options(/MP /wd5105 /wd5030 /wd4996 /Zc:preprocessor)
  add_definitions(/D_CRT_SECURE_NO_WARNINGS)

  if(SANITIZERS)
    set(SAN_FLAGS /fsanitize=address)
    add_compile_options(${SAN_FLAGS})
    add_link_options(${SAN_FLAGS})
  endif()
else()
  add_compile_options(-Wall -pedantic)
  if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    # C++20 allows macros to take zero variadic arguments, but Clang (aka AppleClang on macOS)
    # does not recognize this yet.
    add_compile_options(-Wno-gnu-zero-variadic-macro-arguments)
  endif()
  if(SANITIZERS)
    set(SAN_FLAGS -fsanitize=address -fsanitize=undefined
                  -fsanitize=float-divide-by-zero)
    add_compile_options(${SAN_FLAGS})
    add_link_options(${SAN_FLAGS})
    add_definitions(-D_GLIBCXX_ASSERTIONS)
    # A non-zero optimization level is desired in debug mode, but allow overriding it nonetheless
    set(CMAKE_CXX_FLAGS_DEBUG "-g -Og -fno-omit-frame-pointer -fno-optimize-sibling-calls ${CMAKE_CXX_FLAGS_DEBUG}"
                              CACHE STRING "" FORCE)
  endif()

  if(MORE_WARNINGS)
    add_compile_options(-Werror -Wextra
                        -Walloc-zero -Wcast-align -Wcast-qual -Wduplicated-branches -Wduplicated-cond
                        -Wfloat-equal -Wlogical-op -Wnull-dereference -Wold-style-cast -Wshift-overflow=2
                        -Wstringop-overflow=4 -Wtrampolines -Wundef -Wuninitialized -Wunused -Wshadow
                        -Wformat=2 -Wformat-overflow=2 -Wformat-truncation=1
                        -Wno-format-nonliteral -Wno-strict-overflow
                        -Wno-unused-but-set-variable # bison's `yynerrs_` is incremented but unused
                        -Wno-type-limits -Wno-tautological-constant-out-of-range-compare
                        -Wvla # MSVC does not support VLAs
                        -Wno-unknown-warning-option) # Clang shouldn't diagnose unknown warnings
  endif()
endif()

# Use versioning consistent with Makefile
# the git revision is used but uses the fallback in an archive

find_program(GIT git)
if(GIT)
  execute_process(COMMAND ${GIT} --git-dir=.git -c safe.directory='*' describe --tags --dirty --always
                  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
                  OUTPUT_VARIABLE GIT_REV OUTPUT_STRIP_TRAILING_WHITESPACE
                  ERROR_QUIET)
  message(STATUS "RGBDS version: ${GIT_REV}")
else(GIT)
  message(STATUS "Cannot determine RGBDS version (Git not installed), falling back")
endif(GIT)

find_package(PkgConfig)
if(MSVC OR NOT PKG_CONFIG_FOUND)
  # fallback to find_package
  # cmake's FindPNG is very fragile; it breaks when multiple versions are installed
  # this is most evident on macOS but can occur on Linux too
  find_package(PNG REQUIRED)
else()
  pkg_check_modules(LIBPNG REQUIRED libpng)
endif()

include_directories("${PROJECT_SOURCE_DIR}/include")

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED True)

add_subdirectory(src)
set(CMAKE_CTEST_ARGUMENTS "--verbose")
add_subdirectory(test)

# By default, build in Release mode; Debug mode must be explicitly requested
# (You may want to augment it with the options above)
if(CMAKE_BUILD_TYPE STREQUAL "Release")
  message(CHECK_START "Checking if LTO is supported")
  include(CheckIPOSupported)
  check_ipo_supported(RESULT enable_lto)
  if(enable_lto)
    message(CHECK_PASS "yes")
    set_property(TARGET rgbasm rgblink rgbfix rgbgfx PROPERTY INTERPROCEDURAL_OPTIMIZATION ON)
  else()
    message(CHECK_FAIL "no")
  endif()
endif()

set(MANDIR "share/man")
set(man1 "man/rgbasm.1"
         "man/rgbfix.1"
         "man/rgbgfx.1"
         "man/rgblink.1")
set(man5 "man/rgbasm.5"
         "man/rgbasm-old.5"
         "man/rgblink.5"
         "man/rgbds.5")
set(man7 "man/gbz80.7"
         "man/rgbds.7")

foreach(SECTION "man1" "man5" "man7")
  set(DEST "${MANDIR}/${SECTION}")
  install(FILES ${${SECTION}} DESTINATION ${DEST})
endforeach()

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 .SUFFIXES:
 .SUFFIXES: .cpp .y .o
 
-.PHONY: all clean install checkdiff develop debug profile coverage iwyu mingw32 mingw64 wine-shim dist
+.PHONY: all clean install checkdiff develop debug profile coverage tidy iwyu mingw32 mingw64 wine-shim dist
 
 # User-defined variables
 
@@ -49,7 +49,14 @@
 
 all: rgbasm rgblink rgbfix rgbgfx
 
+common_obj := \
+	src/extern/getopt.o \
+	src/diagnostics.o \
+	src/usage.o
+
 rgbasm_obj := \
+	${common_obj} \
+	src/asm/actions.o \
 	src/asm/charmap.o \
 	src/asm/fixpoint.o \
 	src/asm/format.o \
@@ -64,9 +71,7 @@
 	src/asm/section.o \
 	src/asm/symbol.o \
 	src/asm/warning.o \
-	src/extern/getopt.o \
 	src/extern/utf8decoder.o \
-	src/error.o \
 	src/linkdefs.o \
 	src/opmath.o \
 	src/util.o
@@ -74,7 +79,10 @@
 src/asm/lexer.o src/asm/main.o: src/asm/parser.hpp
 
 rgblink_obj := \
+	${common_obj} \
 	src/link/assign.o \
+	src/link/lexer.o \
+	src/link/layout.o \
 	src/link/main.o \
 	src/link/object.o \
 	src/link/output.o \
@@ -83,34 +91,36 @@
 	src/link/sdas_obj.o \
 	src/link/section.o \
 	src/link/symbol.o \
-	src/extern/getopt.o \
+	src/link/warning.o \
 	src/extern/utf8decoder.o \
-	src/error.o \
 	src/linkdefs.o \
 	src/opmath.o \
 	src/util.o
 
-src/link/main.o: src/link/script.hpp
+src/link/lexer.o src/link/main.o: src/link/script.hpp
 
 rgbfix_obj := \
+	${common_obj} \
 	src/fix/main.o \
-	src/extern/getopt.o \
-	src/error.o
+	src/fix/mbc.o \
+	src/fix/warning.o
 
 rgbgfx_obj := \
+	${common_obj} \
+	src/gfx/color_set.o \
 	src/gfx/main.o \
 	src/gfx/pal_packing.o \
 	src/gfx/pal_sorting.o \
 	src/gfx/pal_spec.o \
+	src/gfx/png.o \
 	src/gfx/process.o \
-	src/gfx/proto_palette.o \
 	src/gfx/reverse.o \
 	src/gfx/rgba.o \
-	src/extern/getopt.o \
-	src/error.o
+	src/gfx/warning.o \
+	src/util.o
 
 rgbasm: ${rgbasm_obj}
-	$Q${CXX} ${REALLDFLAGS} -o $@ ${rgbasm_obj} ${REALCXXFLAGS} src/version.cpp -lm
+	$Q${CXX} ${REALLDFLAGS} -o $@ ${rgbasm_obj} ${REALCXXFLAGS} src/version.cpp
 
 rgblink: ${rgblink_obj}
 	$Q${CXX} ${REALLDFLAGS} -o $@ ${rgblink_obj} ${REALCXXFLAGS} src/version.cpp
@@ -142,6 +152,8 @@
 	$Qtouch $@
 
 # Only RGBGFX uses libpng (POSIX make doesn't support pattern rules to cover all these)
+src/gfx/color_set.o: src/gfx/color_set.cpp
+	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
 src/gfx/main.o: src/gfx/main.cpp
 	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
 src/gfx/pal_packing.o: src/gfx/pal_packing.cpp
@@ -150,9 +162,9 @@
 	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
 src/gfx/pal_spec.o: src/gfx/pal_spec.cpp
 	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
+src/gfx/png.o: src/gfx/png.cpp
+	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
 src/gfx/process.o: src/gfx/process.cpp
-	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
-src/gfx/proto_palette.o: src/gfx/proto_palette.cpp
 	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
 src/gfx/reverse.o: src/gfx/reverse.cpp
 	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
@@ -163,7 +175,6 @@
 	$Q${CXX} ${REALCXXFLAGS} -c -o $@ $<
 
 # Target used to remove all files generated by other Makefile targets
-
 clean:
 	$Q${RM} rgbasm rgbasm.exe
 	$Q${RM} rgblink rgblink.exe
@@ -177,7 +188,6 @@
 	$Q${RM} test/gfx/randtilegen test/gfx/rgbgfx_test
 
 # Target used to install the binaries and man pages.
-
 install: all
 	$Qinstall -d ${DESTDIR}${bindir}/ ${DESTDIR}${mandir}/man1/ ${DESTDIR}${mandir}/man5/ ${DESTDIR}${mandir}/man7/
 	$Qinstall ${STRIP} -m ${BINMODE} rgbasm ${DESTDIR}${bindir}/rgbasm${SUFFIX}
@@ -189,15 +199,13 @@
 	$Qinstall -m ${MANMODE} man/rgbds.7 man/gbz80.7 ${DESTDIR}${mandir}/man7/
 
 # Target used to check for suspiciously missing changed files.
-
 checkdiff:
 	$Qcontrib/checkdiff.bash `git merge-base HEAD ${BASE_REF}`
 
-# This target is used during development in order to prevent adding new issues
-# to the source code. All warnings are treated as errors in order to block the
-# compilation and make the continous integration infrastructure return failure.
+# Target used in development to prevent adding new issues to the source code.
+# All warnings are treated as errors to block the compilation and make the
+# continous integration infrastructure return failure.
 # The rationale for some of the flags is documented in the CMakeLists.
-
 develop:
 	$Q${MAKE} WARNFLAGS="${WARNFLAGS} -Werror -Wextra \
 		-Walloc-zero -Wcast-align -Wcast-qual -Wduplicated-branches -Wduplicated-cond \
@@ -210,26 +218,27 @@
 		-fsanitize=float-divide-by-zero" \
 		CXXFLAGS="-ggdb3 -Og -fno-omit-frame-pointer -fno-optimize-sibling-calls"
 
-# This target is used during development in order to more easily debug with gdb.
-
+# Target used in development to debug with gdb.
 debug:
 	$Qenv ${MAKE} \
 		CXXFLAGS="-ggdb3 -O0 -fno-omit-frame-pointer -fno-optimize-sibling-calls"
 
-# This target is used during development in order to more easily profile with callgrind.
-
+# Target used in development to profile with callgrind.
 profile:
 	$Qenv ${MAKE} \
 		CXXFLAGS="-ggdb3 -O3 -fno-omit-frame-pointer -fno-optimize-sibling-calls"
 
-# This target is used during development in order to inspect code coverage with gcov.
-
+# Target used in development to inspect code coverage with gcov.
 coverage:
 	$Qenv ${MAKE} \
 		CXXFLAGS="-ggdb3 -Og --coverage -fno-omit-frame-pointer -fno-optimize-sibling-calls"
 
-# This target is used during development in order to remove unused `#include` headers.
-
+# Target used in development to check code with clang-tidy.
+# Requires Bison-generated header files to exist.
+tidy: src/asm/parser.hpp src/link/script.hpp
+	$Qclang-tidy -p . $$(find src -name '*.cpp')
+
+# Target used in development to remove unused `#include` headers.
 iwyu:
 	$Qenv ${MAKE} \
 		CXX="include-what-you-use" \

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -3,8 +3,9 @@
 configure_file(version.cpp _version.cpp ESCAPE_QUOTES)
 
 set(common_src
-    "error.cpp"
     "extern/getopt.cpp"
+    "diagnostics.cpp"
+    "usage.cpp"
     "_version.cpp"
     )
 
@@ -34,6 +35,7 @@
 
 set(rgbasm_src
     "${BISON_ASM_PARSER_OUTPUT_SOURCE}"
+    "asm/actions.cpp"
     "asm/charmap.cpp"
     "asm/fixpoint.cpp"
     "asm/format.cpp"
@@ -53,26 +55,11 @@
     "util.cpp"
     )
 
-set(rgbfix_src
-    "fix/main.cpp"
-    )
-
-set(rgbgfx_src
-    "gfx/main.cpp"
-    "gfx/pal_packing.cpp"
-    "gfx/pal_sorting.cpp"
-    "gfx/pal_spec.cpp"
-    "gfx/process.cpp"
-    "gfx/proto_palette.cpp"
-    "gfx/reverse.cpp"
-    "gfx/rgba.cpp"
-    "extern/getopt.cpp"
-    "error.cpp"
-    )
-
 set(rgblink_src
     "${BISON_LINKER_SCRIPT_PARSER_OUTPUT_SOURCE}"
     "link/assign.cpp"
+    "link/lexer.cpp"
+    "link/layout.cpp"
     "link/main.cpp"
     "link/object.cpp"
     "link/output.cpp"
@@ -80,9 +67,30 @@
     "link/sdas_obj.cpp"
     "link/section.cpp"
     "link/symbol.cpp"
+    "link/warning.cpp"
     "extern/utf8decoder.cpp"
     "linkdefs.cpp"
     "opmath.cpp"
+    "util.cpp"
+    )
+
+set(rgbfix_src
+    "fix/main.cpp"
+    "fix/mbc.cpp"
+    "fix/warning.cpp"
+    )
+
+set(rgbgfx_src
+    "gfx/color_set.cpp"
+    "gfx/main.cpp"
+    "gfx/pal_packing.cpp"
+    "gfx/pal_sorting.cpp"
+    "gfx/pal_spec.cpp"
+    "gfx/png.cpp"
+    "gfx/process.cpp"
+    "gfx/reverse.cpp"
+    "gfx/rgba.cpp"
+    "gfx/warning.cpp"
     "util.cpp"
     )

=== debian/changelog ===
rgbds (0.9.4-1) unstable; urgency=medium

  * New upstream release

 -- Sébastien Noel <sebastien@twolife.be>  Sun, 12 Oct 2025 11:46:36 +0200

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_EXTERNAL_TESTS=OFF

=== debian/watch ===
Version: 5
Template: Github
Owner: gbdev
Project: rgbds
Uversion-Mangle: auto

## rgbds 1.0.0

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 .SUFFIXES:
 .SUFFIXES: .cpp .y .o
 
-.PHONY: all clean install checkdiff develop debug profile coverage tidy iwyu mingw32 mingw64 wine-shim dist
+.PHONY: all clean install checkdiff develop debug profile coverage format tidy iwyu mingw32 mingw64 wine-shim dist
 
 # User-defined variables
 
@@ -51,8 +51,11 @@
 
 common_obj := \
 	src/extern/getopt.o \
+	src/cli.o \
 	src/diagnostics.o \
-	src/usage.o
+	src/style.o \
+	src/usage.o \
+	src/util.o
 
 rgbasm_obj := \
 	${common_obj} \
@@ -72,15 +75,17 @@
 	src/asm/symbol.o \
 	src/asm/warning.o \
 	src/extern/utf8decoder.o \
+	src/backtrace.o \
 	src/linkdefs.o \
 	src/opmath.o \
-	src/util.o
+	src/verbosity.o
 
 src/asm/lexer.o src/asm/main.o: src/asm/parser.hpp
 
 rgblink_obj := \
 	${common_obj} \
 	src/link/assign.o \
+	src/link/fstack.o \
 	src/link/lexer.o \
 	src/link/layout.o \
 	src/link/main.o \
@@ -93,14 +98,16 @@
 	src/link/symbol.o \
 	src/link/warning.o \
 	src/extern/utf8decoder.o \
+	src/backtrace.o \
 	src/linkdefs.o \
 	src/opmath.o \
-	src/util.o
+	src/verbosity.o
 
 src/link/lexer.o src/link/main.o: src/link/script.hpp
 
 rgbfix_obj := \
 	${common_obj} \
+	src/fix/fix.o \
 	src/fix/main.o \
 	src/fix/mbc.o \
 	src/fix/warning.o
@@ -112,12 +119,13 @@
 	src/gfx/pal_packing.o \
 	src/gfx/pal_sorting.o \
 	src/gfx/pal_spec.o \
+	src/gfx/palette.o \
 	src/gfx/png.o \
 	src/gfx/process.o \
 	src/gfx/reverse.o \
 	src/gfx/rgba.o \
 	src/gfx/warning.o \
-	src/util.o
+	src/verbosity.o
 
 rgbasm: ${rgbasm_obj}
 	$Q${CXX} ${REALLDFLAGS} -o $@ ${rgbasm_obj} ${REALCXXFLAGS} src/version.cpp
@@ -233,10 +241,14 @@
 	$Qenv ${MAKE} \
 		CXXFLAGS="-ggdb3 -Og --coverage -fno-omit-frame-pointer -fno-optimize-sibling-calls"
 
+# Target used in development to format source code with clang-format.
+format:
+	$Qclang-format -i $$(git ls-files '*.hpp' '*.cpp')
+
 # Target used in development to check code with clang-tidy.
 # Requires Bison-generated header files to exist.
 tidy: src/asm/parser.hpp src/link/script.hpp
-	$Qclang-tidy -p . $$(find src -name '*.cpp')
+	$Qclang-tidy -p . $$(git ls-files '*.hpp' '*.cpp')
 
 # Target used in development to remove unused `#include` headers.
 iwyu:

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -4,8 +4,11 @@
 
 set(common_src
     "extern/getopt.cpp"
+    "cli.cpp"
     "diagnostics.cpp"
+    "style.cpp"
     "usage.cpp"
+    "util.cpp"
     "_version.cpp"
     )
 
@@ -50,14 +53,16 @@
     "asm/symbol.cpp"
     "asm/warning.cpp"
     "extern/utf8decoder.cpp"
+    "backtrace.cpp"
     "linkdefs.cpp"
     "opmath.cpp"
-    "util.cpp"
+    "verbosity.cpp"
     )
 
 set(rgblink_src
     "${BISON_LINKER_SCRIPT_PARSER_OUTPUT_SOURCE}"
     "link/assign.cpp"
+    "link/fstack.cpp"
     "link/lexer.cpp"
     "link/layout.cpp"
     "link/main.cpp"
@@ -69,12 +74,14 @@
     "link/symbol.cpp"
     "link/warning.cpp"
     "extern/utf8decoder.cpp"
+    "backtrace.cpp"
     "linkdefs.cpp"
     "opmath.cpp"
-    "util.cpp"
+    "verbosity.cpp"
     )
 
 set(rgbfix_src
+    "fix/fix.cpp"
     "fix/main.cpp"
     "fix/mbc.cpp"
     "fix/warning.cpp"
@@ -86,12 +93,13 @@
     "gfx/pal_packing.cpp"
     "gfx/pal_sorting.cpp"
     "gfx/pal_spec.cpp"
+    "gfx/palette.cpp"
     "gfx/png.cpp"
     "gfx/process.cpp"
     "gfx/reverse.cpp"
     "gfx/rgba.cpp"
     "gfx/warning.cpp"
-    "util.cpp"
+    "verbosity.cpp"
     )
 
 foreach(PROG "asm" "fix" "gfx" "link")

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,9 @@
 endif()
 if(NOT USE_EXTERNAL_TESTS)
   set(ONLY_INTERNAL "--only-internal")
+endif()
+if(DEFINED OS)
+  set(OS_NAME "--os" "${OS}")
 endif()
 
 add_executable(randtilegen gfx/randtilegen.cpp)
@@ -31,6 +34,6 @@
 endforeach()
 
 add_test(NAME all
-         COMMAND ./run-tests.sh ${ONLY_FREE} ${ONLY_INTERNAL}
+         COMMAND ./run-tests.sh ${ONLY_FREE} ${ONLY_INTERNAL} ${OS_NAME}
          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
 )

=== debian/changelog ===
rgbds (1.0.0-2) unstable; urgency=medium

  * fix FTBFS on alpha.

 -- Sébastien Noel <sebastien@twolife.be>  Tue, 04 Nov 2025 12:20:00 +0100

rgbds (1.0.0-1) unstable; urgency=medium

  * New upstream release.

 -- Sébastien Noel <sebastien@twolife.be>  Tue, 04 Nov 2025 08:30:38 +0100

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,11 @@
 Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Sébastien Noel <sebastien@twolife.be>
-Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13), cmake, bison, pkgconf, libpng-dev
 Standards-Version: 4.7.2
 Homepage: https://rgbds.gbdev.io
-Vcs-Browser: https://salsa.debian.org/twolife/rgbds
-Vcs-Git: https://salsa.debian.org/twolife/rgbds.git
+Vcs-Browser: https://salsa.debian.org/games-team/rgbds
+Vcs-Git: https://salsa.debian.org/games-team/rgbds.git
 
 Package: rgbds
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,11 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
+# Work around FTBFS on Alpha (assembler error "No lda !gpdisp!")
+ifneq (,$(filter $(DEB_HOST_ARCH),alpha))
+  export DEB_CXXFLAGS_MAINT_APPEND += -O1
+endif
 
 %:
 	dh $@ --buildsystem=cmake

## rgbds 1.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -49,7 +49,7 @@
                   -fsanitize=float-divide-by-zero)
     add_compile_options(${SAN_FLAGS})
     add_link_options(${SAN_FLAGS})
-    add_definitions(-D_GLIBCXX_ASSERTIONS)
+    add_definitions(-D_GLIBCXX_ASSERTIONS -D_LIBCPP_HARDENING_MODE=_LIBCPP_HARDENING_MODE_DEBUG)
     # A non-zero optimization level is desired in debug mode, but allow overriding it nonetheless
     set(CMAKE_CXX_FLAGS_DEBUG "-g -Og -fno-omit-frame-pointer -fno-optimize-sibling-calls ${CMAKE_CXX_FLAGS_DEBUG}"
                               CACHE STRING "" FORCE)

=== Makefile ===
--- 
+++ 
@@ -31,7 +31,7 @@
 # Overridable CXXFLAGS
 CXXFLAGS     ?= -O3 -flto -DNDEBUG
 # Non-overridable CXXFLAGS
-REALCXXFLAGS := ${CXXFLAGS} ${WARNFLAGS} -std=c++2a -I include -fno-exceptions -fno-rtti
+REALCXXFLAGS := ${CXXFLAGS} ${WARNFLAGS} -std=c++20 -I include -fno-exceptions -fno-rtti
 # Overridable LDFLAGS
 LDFLAGS      ?=
 # Non-overridable LDFLAGS
@@ -222,8 +222,8 @@
 		-Wformat=2 -Wformat-overflow=2 -Wformat-truncation=1 \
 		-Wno-format-nonliteral -Wno-strict-overflow -Wno-unused-but-set-variable \
 		-Wno-type-limits -Wno-tautological-constant-out-of-range-compare -Wvla \
-		-D_GLIBCXX_ASSERTIONS -fsanitize=address -fsanitize=undefined \
-		-fsanitize=float-divide-by-zero" \
+		-D_GLIBCXX_ASSERTIONS -D_LIBCPP_HARDENING_MODE=_LIBCPP_HARDENING_MODE_DEBUG \
+		-fsanitize=address -fsanitize=undefined -fsanitize=float-divide-by-zero" \
 		CXXFLAGS="-ggdb3 -Og -fno-omit-frame-pointer -fno-optimize-sibling-calls"
 
 # Target used in development to debug with gdb.
@@ -254,7 +254,7 @@
 iwyu:
 	$Qenv ${MAKE} \
 		CXX="include-what-you-use" \
-		REALCXXFLAGS="-std=c++2a -I include"
+		REALCXXFLAGS="-std=c++20 -I include"
 
 # Targets for the project maintainer to easily create Windows exes.
 # This is not for Windows users!

=== debian/changelog ===
rgbds (1.0.1-1) unstable; urgency=medium

  * New upstream release.

 -- Sébastien Noel <sebastien@twolife.be>  Mon, 05 Jan 2026 11:56:43 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: rgbds
 Section: devel
-Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Sébastien Noel <sebastien@twolife.be>
 Build-Depends: debhelper-compat (= 13), cmake, bison, pkgconf, libpng-dev
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://rgbds.gbdev.io
 Vcs-Browser: https://salsa.debian.org/games-team/rgbds
 Vcs-Git: https://salsa.debian.org/games-team/rgbds.git
